> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/api-docs/block-storage-service/default-types.md).

# Default Types

Default volume type management

## List all default volume types

> Get a list of all default volume types (microversion 3.62+)

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"default-types","description":"Default volume type management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"DefaultTypes":{"type":"object","properties":{"default_types":{"type":"array","items":{"$ref":"#/components/schemas/DefaultType"}}}},"DefaultType":{"type":"object","properties":{"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"},"volume_type_id":{"format":"uuid","description":"The UUID of the volume type","type":"string"}}}},"responses":{"NotFound":{"description":"The requested resource could not be found"}}},"paths":{"/v3/default-types":{"get":{"tags":["default-types"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultTypes"}}},"description":"OK"},"404":{"$ref":"#/components/responses/NotFound"}},"summary":"List all default volume types","description":"Get a list of all default volume types (microversion 3.62+)"}}}}
```

## Show default volume type for project

> Show the default volume type for a project (microversion 3.62+)

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"default-types","description":"Default volume type management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"DefaultTypeResponse":{"type":"object","properties":{"default_type":{"$ref":"#/components/schemas/DefaultType"}}},"DefaultType":{"type":"object","properties":{"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"},"volume_type_id":{"format":"uuid","description":"The UUID of the volume type","type":"string"}}}},"responses":{"NotFound":{"description":"The requested resource could not be found"}}},"paths":{"/v3/default-types/{project_id}":{"get":{"tags":["default-types"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultTypeResponse"}}},"description":"OK"},"404":{"$ref":"#/components/responses/NotFound"}},"summary":"Show default volume type for project","description":"Show the default volume type for a project (microversion 3.62+)"}}}}
```

## Set default volume type for project

> Create or update the default volume type for a project (microversion 3.62+)

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"default-types","description":"Default volume type management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"DefaultTypeRequest":{"type":"object","properties":{"default_type":{"required":["volume_type"],"type":"object","properties":{"volume_type":{"description":"The name or UUID for an existing volume type","type":"string"}}}}},"DefaultTypeResponse":{"type":"object","properties":{"default_type":{"$ref":"#/components/schemas/DefaultType"}}},"DefaultType":{"type":"object","properties":{"project_id":{"format":"uuid","description":"The UUID of the project","type":"string"},"volume_type_id":{"format":"uuid","description":"The UUID of the volume type","type":"string"}}}},"responses":{"BadRequest":{"description":"Some content in the request was invalid"},"NotFound":{"description":"The requested resource could not be found"}}},"paths":{"/v3/default-types/{project_id}":{"put":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultTypeRequest"}}},"required":true},"tags":["default-types"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultTypeResponse"}}},"description":"OK"},"400":{"$ref":"#/components/responses/BadRequest"},"404":{"$ref":"#/components/responses/NotFound"}},"summary":"Set default volume type for project","description":"Create or update the default volume type for a project (microversion 3.62+)"}}}}
```

## Unset default volume type for project

> Unset the default volume type for a project (microversion 3.62+)

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"default-types","description":"Default volume type management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"responses":{"NotFound":{"description":"The requested resource could not be found"}}},"paths":{"/v3/default-types/{project_id}":{"delete":{"tags":["default-types"],"responses":{"204":{"description":"No Content"},"404":{"$ref":"#/components/responses/NotFound"}},"summary":"Unset default volume type for project","description":"Unset the default volume type for a project (microversion 3.62+)"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.platform9.com/api-docs/block-storage-service/default-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
